unit HmsAddonsIntfTypes;

interface

uses
  {$IFDEF MSWINDOWS} ActiveX {$ELSE} Types {$ENDIF};

const
{ IHmsScriptEditor.GetCapabilities }

  ecEditor    = 1;
  ecStatusBar = 2;
  ecMessages  = 4;

{ IHmsScriptFrame.ProcessCommand }

  ecUserFirst       = 1001; // Start of user-defined commands

  ecCompileScript    = ecUserFirst + 103;
  ecRunLine          = ecUserFirst + 100;
  ecRunScript        = ecUserFirst + 102;
  ecToggleBreakpoint = ecUserFirst + 101;
  ecEvaluate         = ecUserFirst + 104;
  ecWatches          = ecUserFirst + 105;

{ IHmsAddonTools.Update flags }

  ufCheckExistsOnly  = $01; //   
  ufIsHttpLink       = $02; //  - http-  zip- 
  ufIsLocalFile      = $04; //  -  zip- 
  ufIsInfoMessage    = $08; //  -  
  ufIsErrorMessage   = $10; //  -   
  ufIsWarningMessage = $20; //  - ,  


const
  CLASS_HmsAddonList: TGUID = '{1C6BC2D4-5AF8-4203-98D3-5D4CA48E6C6F}';

  IID_HmsAddonClientConfig = '{5C801BA1-1B1A-4334-8AB5-F3B4F7BB50F6}';
  IID_HmsAddonClientInfo = '{3D8943AC-3CC1-4A94-849E-5E2686DF6FE0}';
  IID_HmsAddonInit = '{3AB5A0DB-190F-40AA-9FA3-88CC34432365}';
  IID_HmsAddonList = '{A8F688A7-441E-4701-9EA0-9C591D0B997A}';
  IID_HmsAddonMediaItem = '{097D84B0-B557-4C03-BDEE-0D6E9E405DE5}';
  IID_HmsAddonMediaItemListNavigator = '{BAF6D656-D927-4A56-89FF-DF79C258D546}';
  IID_HmsAddonTools = '{C5B24BFB-1F30-4F8A-91AD-943B82D8A067}';
  IID_HmsApplication = '{99C4E03E-8044-4431-A53D-B9E999884B2E}';
  IID_HmsFileScanner = '{9A42CD2F-7644-40FF-925D-B808FEB4229B}';
  IID_HmsFormProvider = '{6BC29D8C-77BD-48D2-A310-35C9F1374581}';
  IID_HmsMainFormControl = '{6E86502E-15BC-4358-A4A1-29D97CDEF073}';
  IID_HmsScriptEditor = '{B43BB779-379D-4244-A53D-0AAC3863A0FB}';
  IID_HmsScriptFrame = '{D31B4638-9764-4A9A-9F5A-B4D0B519F402}';
  IID_HmsScriptFunctions = '{99546421-6D4B-4BEB-B778-285591F25D79}';
  IID_HmsScripter = '{786039DF-E1B1-466C-AF74-A6B1DAB2F8AE}';
  IID_HmsThumbnailsManager = '{EFBB29E2-C170-4B33-ACAB-832F4443C070}';

type
  IBaseInterface = IDispatch;

  IHmsAddonTools = interface(IBaseInterface)
  [IID_HmsAddonTools]
    function Setup(aOwner: THandle; var aReload: LongBool): HResult; safecall;
    function Update(var aFlags: Integer; var aResult: OleVariant): HResult; safecall;
  end;

  IHmsAddonList = interface(IBaseInterface)
  [IID_HmsAddonList]
    function GetCount(var aCount: Integer): HResult; safecall;
    function GetAddonInfo(aIndex: Integer; var aClassID, aInterfaceID: TGUID;
        var aTitle, aDescription, aRequiredVersion, aCheckedOnVersion: OleVariant): HResult; safecall;
    function GetClassObject(const clsid: TGUID; const iid: TGUID; out pv: OleVariant): HResult; safecall;
    function CanUnloadNow: HResult; safecall;
  end;

  IHmsScriptFrame = interface(IBaseInterface)
  [IID_HmsScriptFrame]
    function AddWatch(const aExpression: OleVariant): HResult; safecall;

    function ChangeScriptName(const aScriptName: OleVariant): HResult; safecall;

    function CompileScript(const aScriptName, aScriptText: OleVariant; var aErrorMessage: OleVariant;
                           var aErrorLine, aErrorChar: Integer; var aResult: LongBool): HResult; safecall;

    function GenerateScriptDescriptions(var aXMLDescriptions: OleVariant): HResult; safecall;

    function GetCurrentState(var aRunning: LongBool;
                  var aCurrentSourceLine, aCurrentSourceChar: Integer): HResult; safecall;

    function IsBreakpointLine(aLine: Integer; var aResult: LongBool): HResult; safecall;
    function IsExecutableLine(aLine: Integer; var aResult: LongBool): HResult; safecall;

    function ProcessCommand(aCommand: Integer): HResult; safecall;

    function SolveExpression(const aExpression: OleVariant; var aResult: OleVariant): HResult; safecall;

    function ToggleBreakpoint(aLine: Integer): HResult; safecall;
  end;

{  THmsScriptMode = (
    smUnknown,
    smTranscoding,
    smWatchFoldersGroupName,
    smMediaInfo,
    smProcessMedia,
    smCreateFolderItems,
    smPodcastItemProperties,
    smMediaResourceLink,
    smWebMediaItems,
    smMimeType,
    smProcessMediaEvent,
    smCreatePodcastFeeds,
    smWebNavigation,
    smParsePlaylistFile,
    smAutoDetectDeviceType,
    smProcessMetadata,
    smDIDLLiteDescription,
    smHandleHTTPRequest); }

type
  THmsAddonType = (atUnknown, atScriptEditor, atMainFormControl, atScriptFunctions, atFormProvider);

  IHmsScriptEditor = interface(IBaseInterface)
  [IID_HmsScriptEditor]
    function AddMessage(const aMessage: OleVariant): HResult; safecall;

    function CreateEditor(aParent: THandle; const aHmsScripter: IHmsScriptFrame;
                   aScriptMode: Integer; var aEditor: THandle): HResult; safecall;

    function DestroyEditor(aEditor: THandle): HResult; safecall;

    function GetCapabilities(var aCapabilities: Integer): HResult; safecall;

    function GetCurrentLine(var aLine: Integer): HResult; safecall;

    function GetScriptName(var aScriptName: OleVariant): HResult; safecall;
    function GetScriptText(var aText: OleVariant): HResult; safecall;
    function SetScriptName(const aScriptName: OleVariant): HResult; safecall;
    function SetScriptText(const aText: OleVariant): HResult; safecall;

    function GetModified(var aModified: LongBool): HResult; safecall;

    function InvalidateLine(aLineIndex: Integer): HResult; safecall;

    function Repaint: HResult; safecall;

    function GetCaretPos(var aLine, aChar: Integer): HResult; safecall;
    function SetCaretPos(aLine, aChar: Integer): HResult; safecall;

    function SetFocus: HResult; safecall;

    function SetRunning(aValue: LongBool): HResult; safecall;

    function SetSelText(const aText: OleVariant): HResult; safecall;

    function Setup: HResult; safecall;
  end;

  IHmsMainFormControl = interface(IBaseInterface)
  [IID_HmsMainFormControl]
    function CreateControl(aParent: THandle; const aReserved: IUnknown; var aControl: THandle): HResult; safecall;
    function DestroyControl(aControl: THandle): HResult; safecall;

    function GetCaption(var aCaption: OleVariant): HResult; safecall;
    function SetFocus: HResult; safecall;

    function ExecuteAction(const aActionName: OleVariant; const aActionParameters: OleVariant): HResult; safecall;
    function GetActionCount(var aCount: Integer): HResult; safecall;
    function GetActionInfo(aIndex: Integer; var aActionName, aActionTitle, aActionDescription: OleVariant): HResult; safecall;
  end;

  IHmsScriptFunctions = interface(IBaseInterface)
  [IID_HmsScriptFunctions]
    function ExecuteFunction(const aFunctionName: OleVariant; var aFunctionParameters, aFunctionResult: OleVariant): HResult; safecall;
    function GetFunctionCount(var aCount: Integer): HResult; safecall;
    function GetFunctionInfo(aIndex: Integer; var aFunctionName, aFunctionDeclaration,
                              aFunctionCategory, aFunctionDescription: OleVariant): HResult; safecall;
  end;

  IHmsFormProvider = interface(IBaseInterface)
  [IID_HmsFormProvider]
    function ShowModal(aOwner: THandle; const aFormClassName: OleVariant; var aParameters: OleVariant; var aModalResult: Integer): HResult; safecall;
  end;

(*
  aParameters -    (__1, __1, __2, __2, ..., __N, __N);
   IHmsFormProvider.ShowModal   S_OK,      .

const
{   aModalResult }
  idOK       = 1;
  idCancel   = 2;
  idAbort    = 3;
  idRetry    = 4;
  idIgnore   = 5;
  idYes      = 6;
  idNo       = 7;
  idClose    = 8;
  idHelp     = 9;
  idTryAgain = 10;
  idContinue = 11;
  mrNone     = 0;
  mrOk       = idOk;
  mrCancel   = idCancel;
  mrAbort    = idAbort;
  mrRetry    = idRetry;
  mrIgnore   = idIgnore;
  mrYes      = idYes;
  mrNo       = idNo;
  mrClose    = idClose;
  mrHelp     = idHelp;
  mrTryAgain = idTryAgain;
  mrContinue = idContinue;
  mrAll      = mrContinue + 1;
  mrNoToAll  = mrAll + 1;
  mrYesToAll = mrNoToAll + 1; *)

  IHmsAddonMediaItem = interface(IBaseInterface)
  [IID_HmsAddonMediaItem]
    function GetProperties(const aIndexOrName: OleVariant): OleVariant; safecall;
    procedure SetProperties(const aIndexOrName, aPropertyValue: OleVariant); safecall;

    function ExecuteMethod(const aMethodName: OleVariant; var aMethodParameters: OleVariant): OleVariant; safecall;

    function PropertyExists(const aIndexOrName: OleVariant): LongBool; safecall;

    property Properties[const aIndexOrName: OleVariant]: OleVariant read GetProperties write SetProperties; default;
  end;

(* aIndexOrName -     

  'FolderOrigin' - -   (IHmsAddonMediaItem)
  'FolderSortOrder' -  
  'FolderType' -   (ftDefaultFolder = 0, ftDynamicFolder, ftTranscodingFolder, ftGroupByFolder, ftPodcastSubFolder, ftDeviceDynamicFolde)
  'HideItem'  -  -
  'IsArchiveItem' - -  
  'IsBdItem' - -  Bluray-
  'IsCueFileItem' - -  CueSheet
  'IsDvbItem' - -  
  'IsDvdItem' - -  DVD-
  'IsDirectLink' -  True,        -
  'IsFolder' - True,    
  'IsInternetItem' - True,     -  -
  'IsInternetRadio' - True,     -
  'IsIsoItem' - -   
  'IsLink' -   
  'IsMixedItem' - -   "    "
  'IsOriginalLink' -   -   
  'IsPodcast' -    
  'IsStreamItem' - IsDvbItem  IsInternetItem  IsPodcast
  'IsTempItem' - ,       (,  ,  )
  'IsUrlItem' - IsInternetItem    ://
  'IsVirtualVideo'     ()   (-)
  'IsWebShot' -     webshot:// ( Web-)
  'ItemBookmarkPath' -    
  'ItemDate' -  -
  'ItemExists' - True,       
  'ItemID' -  -
  'ItemIDPath' -  -  
  'ItemImageIndex' -   -
  'ItemImagePath' -    -  Web-
  'ItemIsoURL' -  -   
  'ItemOrigin' - -   (IHmsAddonMediaItem)
  'ItemParent' -   (IHmsAddonMediaItem)
  'ItemPath' -   ( , -)
  'ItemRotate' -  
  'ItemSafeID' - ItemID   , ItemIDPath -   
  'ItemSize' -  -  
  'ItemState' -  
  'ItemTimeLength' -  -
  'ItemTitle' -  -
  'MediaResourceSource' -  -  
  'MediaType' -  - (mtUnknown, mtAudio, mtImage, mtVideo, mtText, mtIsoDisk, mtCueSheet, mtPlaylist)
  'OriginalPath' - ,    
  'RatingsOrigin' - -   
  'RootItem' -  
  'ShortItemID' -  (16 )  
  'Transcoding' - True,        
  'Thumbnail' -  -
  'ThumbnailExists' - True,      (, ) 
  'ThumbnailFileName' -   
  'ThumbnailKey' -     
  'ThumbnailOrigin' - -   (IHmsAddonMediaItem) *)

  IHmsAddonMediaItemListNavigator = interface(IBaseInterface)
  [IID_HmsAddonMediaItemListNavigator]
    procedure GotoBOF; safecall;
    procedure GotoPrev; safecall;
    procedure GotoNext; safecall;
    procedure GotoEOF; safecall;
    function IsBOF: LongBool; safecall;
    function IsEOF: LongBool; safecall;
    function IsTreeList: LongBool; safecall;
    function CurrentMediaItem: OleVariant; safecall;
  end;

  IHmsAddonClientConfig = interface(IBaseInterface)
  [IID_HmsAddonClientConfig]
    function GetProperties(const aIndexOrName: OleVariant): OleVariant; safecall;
    procedure SetProperties(const aIndexOrName, aPropertyValue: OleVariant); safecall;
    function ExecuteMethod(const aMethodName: OleVariant; var aMethodParameters: OleVariant): OleVariant; safecall;
  end;

  IHmsAddonClientInfo = interface(IBaseInterface)
  [IID_HmsAddonClientInfo]
    function GetProperties(const aIndexOrName: OleVariant): OleVariant; safecall;
    procedure SetProperties(const aIndexOrName, aPropertyValue: OleVariant); safecall;
    function ExecuteMethod(const aMethodName: OleVariant; var aMethodParameters: OleVariant): OleVariant; safecall;
  end;

  IHmsApplication = interface(IBaseInterface)
  [IID_HmsApplication]
    function GetInterface(const aInterfaceID: TGUID; out aObject: OleVariant): HResult; safecall;
  end;

  IHmsScripter = interface(IBaseInterface)
  [IID_HmsScripter]
    function CreateScript(const aClientInfo: OleVariant; aScriptMode: Integer): LongBool; safecall;
    function CompileScript(const aScriptName, aScriptText: OleVariant;
         var aErrorMessage: OleVariant; var aErrorLine, aErrorChar: Integer): LongBool; safecall;
    function ExecuteScript(const aInParameters: OleVariant; var aOutParameters: OleVariant): LongBool; safecall;
  end;

  IHmsThumbnailsManager = interface(IBaseInterface)
  [IID_HmsThumbnailsManager]
    function AddThumbnail(const aThumbnailKey, aThumbnailFormat: OleVariant;
                          aThumbnailWidth, aThumbnailHeight: Integer;
                          const aThumbnailStream: IStream): LongBool; safecall;
    function CreateThumbnail(const aThumbnailKey: OleVariant; var aCreateParameters: OleVariant): LongBool; safecall;

    function GetThumbnail(const aThumbnailKey: OleVariant;
                          const aThumbnailStream: IStream): LongBool; safecall;
    function GetThumbnailInfo(const aThumbnailKey: OleVariant;
                              var aThumbnailFormat: OleVariant;
                              var aThumbnailWidth, aThumbnailHeight: Integer): LongBool; safecall;
    function ThumbnailExists(const aThumbnailKey: OleVariant): LongBool; safecall;
  end;

  IHmsAddonInit = interface(IBaseInterface)
  [IID_HmsAddonInit]
    procedure SetApplication(const aApplication: IHmsApplication); safecall;
  end;

  IHmsFileScanner = interface(IBaseInterface)
  [IID_HmsFileScanner]
    function GetFileExtensions: OleVariant; safecall;
    function ScanFile(const aFileName: OleVariant): LongBool; safecall;
  end;

var
  HmsApplication: IHmsApplication = nil;

implementation

end.
